//+------------------------------------------------------------------+
//|                                             Exp_ColorStochNR.mq5 |
//|                             Copyright  2012,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum AlgMode
  {
   Breakdown,  //  50 
   OscTwist,  //  
   SignalTwist,//   
   OscDisposition, //   
   SignalBreakdown  //  50  
  };
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum ENUM_MA_METHOD_
  {
   MODE_SMA_,       //  
   MODE_EMA_        // 
  };
//+----------------------------------------------+
//|                      |
//+----------------------------------------------+
input double  MM=-0.1;             //      ,   -  
input int     StopLoss_=1000;      //  
input int     TakeProfit_=2000;    //  
input int     Deviation_=10;       //.    
input bool    BuyPosOpen=true;     //    
input bool    SellPosOpen=true;    //    
input bool    BuyPosClose=true;    //    
input bool    SellPosClose=true;   //    
input AlgMode Mode=OscDisposition; //    
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_H4; // 

input uint Kperiod=5;  // K period
input uint Dperiod=3;  // D period
input uint Slowing=3;  // Slowing
input ENUM_MA_METHOD_ Dmethod=MODE_SMA_; //  
input ENUM_STO_PRICE PriceFild=STO_LOWHIGH; //   
input uint Sens=0; //   

input uint SignalBar=1;//     
//+----------------------------------------------+
//----          
int TimeShiftSec;
//----      
int InpInd_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----    ColorStochNR
   InpInd_Handle=iCustom(Symbol(),InpInd_Timeframe,"ColorStochNR",
                         Kperiod,Dperiod,Slowing,Dmethod,PriceFild,Sens,0);
   if(InpInd_Handle==INVALID_HANDLE) Print("      ColorStochNR");

//----          
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);

//----     
   min_rates_total=int(Kperiod+Dperiod+Slowing+1);
   min_rates_total+=int(3+SignalBar);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   GlobalVariableDel_(Symbol());
//----
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//----       
   if(BarsCalculated(InpInd_Handle)<min_rates_total) return;

//----       IsNewBar()  SeriesInfoInteger()  
   LoadHistory(TimeCurrent()-PeriodSeconds(InpInd_Timeframe)-1,Symbol(),InpInd_Timeframe);

//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB;

//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
   if(!SignalBar || NB.IsNewBar(Symbol(),InpInd_Timeframe) || Recount) //     
     {
      //----   
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;
      Recount=false;

      switch(Mode)
        {
         case Breakdown:
           {
            double UpValue[2],DnValue[2];
            //----      
            if(CopyBuffer(InpInd_Handle,0,SignalBar,2,UpValue)<=0) {Recount=true; return;}
            if(CopyBuffer(InpInd_Handle,1,SignalBar,2,DnValue)<=0) {Recount=true; return;}

            //----    
            if(UpValue[1]>50)
              {
               if(BuyPosOpen && DnValue[0]<=50) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(DnValue[1]<50)
              {
               if(SellPosOpen && UpValue[0]>=50) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;

         case OscTwist:
           {
            double Value[2];
            //----      
            if(CopyBuffer(InpInd_Handle,2,SignalBar,2,Value)<=0) {Recount=true; return;}

            //----    
            if(Value[1]==1 && Value[0]>1 || Value[1]==2 && Value[0]>2 || Value[1]==3 && Value[0]==4)
              {
               if(BuyPosOpen && Value[0]>Value[1]) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(Value[1]==4 && (Value[0]<4 && Value[0]) || Value[1]==3 && (Value[0]<3 && Value[0]) || Value[1]==2 && Value[0]<=1)
              {
               if(SellPosOpen && Value[0]<Value[1]) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;

         case SignalTwist:
           {
            double Value[3];
            //----      
            if(CopyBuffer(InpInd_Handle,3,SignalBar,3,Value)<=0) {Recount=true; return;}

            //----    
            if(Value[1]<Value[2])
              {
               if(BuyPosOpen && Value[0]>Value[1]) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(Value[1]>Value[2])
              {
               if(SellPosOpen && Value[0]<Value[1]) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;
         
         case OscDisposition:
           {
            double Signal[2];
            //----      
            if(CopyBuffer(InpInd_Handle,4,SignalBar,2,Signal)<=0) {Recount=true; return;}

            //----    
            if(Signal[1]==1)
              {
               if(BuyPosOpen) if(Signal[0]==2 || Signal[0]) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(Signal[1]==2)
              {
               if(SellPosOpen) if(Signal[0]==1 || Signal[0]) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;
         
         case SignalBreakdown:
           {
            double Signal[2];
            //----      
            if(CopyBuffer(InpInd_Handle,4,SignalBar,2,Signal)<=0) {Recount=true; return;}

            //----    
            if(Signal[1]>50)
              {
               if(BuyPosOpen && Signal[0]<=50) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(Signal[1]<50)
              {
               if(SellPosOpen && Signal[0]>=50) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;
        }
     }

//+----------------------------------------------+
//|                              |
//+----------------------------------------------+
//----  
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);

//----     
   SellPositionClose(SELL_Close,Symbol(),Deviation_);

//----  
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);

//----  
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);
//----
  }
//+------------------------------------------------------------------+
